/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Annotations;

/**
* \class JSOptionDefinition - Annotation fr eine JSOption
* 
* \brief JSOptionDefinition - Annotation fr eine JSOption
* 
* \details
*
* \section JSOptionDefinition.java_intro_sec Introduction
*
* \section JSOptionDefinition.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id: JSOptionDefinition.java 14731 2011-07-05 20:50:42Z sos $14.06.2009
* \see reference
*
* Created on 14.06.2009 15:06:34
 */
import static java.lang.annotation.ElementType.FIELD;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target( { FIELD })
@Retention(RetentionPolicy.RUNTIME)
public @interface JSOptionDefinition {

	/**
	 * 
	 * \brief name - Der Name der Option
	 * 
	 * \details
	 * Hier wird der Name der Option angegeben.
	 * Mit diesem Namen wird die Option von "aussen" angesprochen.
	 * 
	 * Das Schlsselwort mu in der Annotation angegeben werden.
	 * \return String
	 *
	 */
	String name();

	/**
	 * 
	 * \brief description - Kurzbeschreibung der Option
	 * 
	 * \details
	 * Mit diesem Schlsselwort wird eine Kurzbeschreibung der Option angegeben.
	 * Diese Kurzbeschreibung wird verwendet in der Ausgabe, z.B. in den Protokollen
	 * zur Laufzeit oder in der Prfung auf Vorhandensein (siehe 
	 * Eigenschaft "mandatory").
	 * 
	 * Das Schlsselwort mu in der Annotation angegeben werden.
	 * \return String
	 *
	 */
	String description();
	/**
	 * 
	 * \brief key - Schlssel der Option
	 * 
	 * \details
	 * Mit dem Schlssel wird festgelegt, wie die Option z.B. in einer HashMap oder einer Property-Datei
	 * abgelegt ist bzw. wird.
	 * Der Schlssel kann mit dem Namen der Optionklasse ergnzt werden. Dann wird der Name der Klasse
	 * als Prfix verwendet.
	 * 
	 * Das Schlsselwort mu nicht angegeben werden, es ist optional.
	 * Wird es nicht angegeben, so wird als Wert der Wert des Attributes "name" verwendet.
	 * \example
	 * @JSOptionDefinition (name"HostName", description="Name of FTP-Host/Server", key="HostName" )
	 * 
	 * \return String
	 *
	 * @return
	 */
	String key() default "";
	/**
	 * 
	 * \brief xmltagname - Name der Option in der XML-Ausgabe
	 * 
	 * \details
	 * Mit diesem Attribut der Annotation wird der Name des XML-Tags festgelegt, der in der Ausgabe im
	 * XML-Format (siehe Methode toXML() ) verwendet wird.
	 * 
	 * Das Schlsselwort mu nicht angegeben werden, es ist optional.
	 * Wird es nicht angegeben, so wird als Wert der Wert des Attributes "name" verwendet.
	 * 
	 * \return String
	 *
	 * @return
	 */
	String xmltagname() default "";
	int size() default -1;
	//	int pos();
	boolean mandatory() default false;
	String type() default "JSOptionString";
	String value() default "";
	String defaultvalue() default "";

} // public @interface JSOptionDefinition
