/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.engine.kernel.order.jobchain;

import com.sos.scheduler.engine.kernel.scheduler.AbstractHasPlatform;
import com.sos.scheduler.engine.kernel.scheduler.Platform;
import com.sos.scheduler.engine.kernel.cppproxy.NodeC;
import com.sos.scheduler.engine.kernel.cppproxy.NodeCI;
import com.sos.scheduler.engine.kernel.cppproxy.Order_queue_nodeC;
import com.sos.scheduler.engine.kernel.order.OrderState;
import com.sos.scheduler.engine.cplusplus.runtime.Sister;
import com.sos.scheduler.engine.cplusplus.runtime.SisterType;

/**
 *
 * @author Zschimmer.sos
 */
public class Node extends AbstractHasPlatform implements Sister {
    private final NodeCI nodeC;


    Node(Platform platform, NodeCI nodeC) {
        super(platform);
        this.nodeC = nodeC;
    }


    @Override public final void onCppProxyInvalidated() {}


    public final OrderState getOrderState() { return OrderState.of(nodeC.string_order_state()); }
    public final OrderState getNextState() { return OrderState.of(nodeC.string_next_state()); }
    public final OrderState getErrorState() { return OrderState.of(nodeC.string_error_state()); }


    public static class Type implements SisterType<Node, NodeC> {
        @Override public Node sister(NodeC proxy, Sister context) {
            NodeCI nodeCI = proxy;
            return nodeCI instanceof Order_queue_nodeC?
                Order_queue_nodeC.sisterType.sister((Order_queue_nodeC)nodeCI, context)
              : new Node(Platform.of(context), proxy);
        }
    }
}
