/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: sossock1.h 11394 2005-04-03 08:30:29Z jz $

#ifndef __SOS_SOSSOCK1_H
#define __SOS_SOSSOCK1_H


#if defined SYSTEM_WIN

#   include <winsock.h>

    typedef unsigned int SOCKET;
    typedef int          socklen_t;

#else

    extern "C" 
    {
#		if !defined SYSTEM_GNU
#       	include <sys/types.h>
#		endif

#       include <errno.h>

#       include <sys/socket.h>
#       include <sys/ioctl.h>
#       include <netdb.h>
#       include <netinet/in.h>   // gethostbyname()
#       include <arpa/inet.h>    // inet_addr()
#       include <unistd.h>       // close()
    }

    typedef int SOCKET;

    inline int closesocket( SOCKET s )
    {
        return close( s );
    }

    inline int ioctlsocket( SOCKET s, long a, u_long* b )
    {
        return ioctl( s, a, b );
    }

#   if defined SYSTEM_SOLARIS

#       include <sys/filio.h>       // ioctl( , FIONBIO )
#       include <sys/utsname.h>     // uname()

#   elif defined SYSTEM_LINUX

        extern "C" 
        {
#           include </usr/include/linux/errno.h>
#           include <sys/ioctl.h>       // ioctl
#           include <asm/ioctls.h>      // FIONBIO
#           include <sys/utsname.h>     // struct utsname, uname()
        }

#endif

#endif


namespace sos
{
    void throw_sos_socket_error( int errno_, const char* insertion );
    void throw_sos_socket_error( const char* insertion );
    void throw_sos_socket_error( const char* insertion, const char* ins2 );
}

#endif
