/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/* soswncom.h                                    (c) SOS GmbH Berlin
                                                     Joacim Zschimmer

   Klasse Sos_mswin_comm fr Kommunikation ber MS-Windows-Botschaften (SOS-spezifisch).
*/

#ifndef __SOSWNCOM_H
#define __SOSWNCOM_H

#if !defined __SOSOBJ_H
#   include <sosobj.h>
#endif

#if defined SYSTEM_WIN
    //#ifdef __WINDOWS_H
    //    const sos_socket_msg = WM_USER;
    //#endif
    SOS_DECLARE_MSWIN_HANDLE( HWND )
#endif

struct Mswin_comm_buffer;

struct Sos_mswin_comm : Sos_msg_filter, Has_mswin_message_handler
{
    BASE_CLASS( Sos_msg_filter )

                                Sos_mswin_comm          ( Sos_object* creator );
  //virtual                    ~Sos_mswin_comm          ();

    static int                  open_event_count        ();

    void                        try_send                ();
    void                        try_receive             ();

  protected:
    void                       _obj_run_msg             ( Run_msg* );
    void                       _obj_data_msg            ( Data_msg* );
    void                       _obj_ack_msg             ( const Ack_msg* );
  //void                       _obj_end_msg             ( End_msg* );
  //void                       _obj_get_msg             ( Get_msg* );
  //void                       _obj_print               ( ostream* s ) const;

  private:
    friend class                Sos_mswin_comm_manager;
    long                        mswin_message_handler   ( HWND, UINT, WPARAM, LPARAM, Bool* );

    Sos_mswin_comm_manager*    _manager_ptr;
    Sos_object*                _factory_ptr;        // Nur fr Konstruktion
    Sos_object*                _input_ptr;

    HWND                       _hwnd;
    Mswin_comm_buffer*         _send_buffer_ptr;
    HWND                       _remote_hwnd;
    Mswin_comm_buffer*         _remote_data_ptr;
    Bool                       _run_mode;
    uint                       _msg;
};

#endif
